// ===============================================================================================
//    I-O|[gAhX
// ===============================================================================================

#define KBCOMP	(*(volatile unsigned char *)0xFFFEE4)
#define DDCSWR	(*(volatile unsigned char *)0xFFFEE6)
#define ICRA	(*(volatile unsigned char *)0xFFFEE8)
#define ICRB	(*(volatile unsigned char *)0xFFFEE9)
#define ICRC	(*(volatile unsigned char *)0xFFFEEA)
#define ISR		(*(volatile unsigned char *)0xFFFEEB)
#define ISCRH	(*(volatile unsigned char *)0xFFFEEC)
#define ISCRL	(*(volatile unsigned char *)0xFFFEED)
#define DTCERA	(*(volatile unsigned char *)0xFFFEEE)
#define DTCERB	(*(volatile unsigned char *)0xFFFEEF)
#define DTCERC	(*(volatile unsigned char *)0xFFFEF0)
#define DTCERD	(*(volatile unsigned char *)0xFFFEF1)
#define DTCERE	(*(volatile unsigned char *)0xFFFEF2)
#define DTVECR	(*(volatile unsigned char *)0xFFFEF3)
#define ABRKCR	(*(volatile unsigned char *)0xFFFEF4)
#define BARA	(*(volatile unsigned char *)0xFFFEF5)
#define BARB	(*(volatile unsigned char *)0xFFFEF6)
#define BARC	(*(volatile unsigned char *)0xFFFEF7)
#define FLMCR1	(*(volatile unsigned char *)0xFFFF80)
#define FLMCR2	(*(volatile unsigned char *)0xFFFF81)
#define PCSR	(*(volatile unsigned char *)0xFFFF82)
#define EBR1	(*(volatile unsigned char *)0xFFFF82)
#define SYSCR2	(*(volatile unsigned char *)0xFFFF83)
#define EBR2	(*(volatile unsigned char *)0xFFFF83)
#define SBYCR	(*(volatile unsigned char *)0xFFFF84)
#define LPWRCR	(*(volatile unsigned char *)0xFFFF85)
#define MSTPCRH	(*(volatile unsigned char *)0xFFFF86)
#define MSTPCRL	(*(volatile unsigned char *)0xFFFF87)
#define SMR1	(*(volatile unsigned char *)0xFFFF88)
#define ICCR1	(*(volatile unsigned char *)0xFFFF88)
#define BRR1	(*(volatile unsigned char *)0xFFFF89)
#define ICSR1	(*(volatile unsigned char *)0xFFFF89)
#define SCR1	(*(volatile unsigned char *)0xFFFF8A)
#define TDR1	(*(volatile unsigned char *)0xFFFF8B)
#define SSR1	(*(volatile unsigned char *)0xFFFF8C)
#define RDR1	(*(volatile unsigned char *)0xFFFF8D)
#define SCMR1	(*(volatile unsigned char *)0xFFFF8E)
#define ICDR1	(*(volatile unsigned char *)0xFFFF8E)
#define SARX1	(*(volatile unsigned char *)0xFFFF8E)
#define ICMR1	(*(volatile unsigned char *)0xFFFF8F)
#define SAR1	(*(volatile unsigned char *)0xFFFF8F)
#define TIER	(*(volatile unsigned char *)0xFFFF90)
#define TCSR	(*(volatile unsigned char *)0xFFFF91)
#define FRCH	(*(volatile unsigned char *)0xFFFF92)
#define FRCL	(*(volatile unsigned char *)0xFFFF93)
#define OCRAH	(*(volatile unsigned char *)0xFFFF94)
#define OCRBH	(*(volatile unsigned char *)0xFFFF94)
#define OCRAL	(*(volatile unsigned char *)0xFFFF95)
#define OCRBL	(*(volatile unsigned char *)0xFFFF95)
#define TCR		(*(volatile unsigned char *)0xFFFF96)
#define TOCR	(*(volatile unsigned char *)0xFFFF97)
#define ICRAH	(*(volatile unsigned char *)0xFFFF98)
#define OCRARH	(*(volatile unsigned char *)0xFFFF98)
#define ICRAL	(*(volatile unsigned char *)0xFFFF99)
#define OCRARL	(*(volatile unsigned char *)0xFFFF99)
#define ICRBH	(*(volatile unsigned char *)0xFFFF9A)
#define OCRAFH	(*(volatile unsigned char *)0xFFFF9A)
#define ICRBL	(*(volatile unsigned char *)0xFFFF9B)
#define OCRAFL	(*(volatile unsigned char *)0xFFFF9B)
#define ICRCH	(*(volatile unsigned char *)0xFFFF9C)
#define OCRDMH	(*(volatile unsigned char *)0xFFFF9C)
#define ICRCL	(*(volatile unsigned char *)0xFFFF9D)
#define OCRDML	(*(volatile unsigned char *)0xFFFF9D)
#define ICRDH	(*(volatile unsigned char *)0xFFFF9E)
#define ICRDL	(*(volatile unsigned char *)0xFFFF9F)
#define SMR2	(*(volatile unsigned char *)0xFFFFA0)
#define DADRAH	(*(volatile unsigned char *)0xFFFFA0)
#define DACR_	(*(volatile unsigned char *)0xFFFFA0)
#define BRR2	(*(volatile unsigned char *)0xFFFFA1)
#define DADRAL	(*(volatile unsigned char *)0xFFFFA1)
#define SCR2	(*(volatile unsigned char *)0xFFFFA2)
#define TDR2	(*(volatile unsigned char *)0xFFFFA3)
#define SSR2	(*(volatile unsigned char *)0xFFFFA4)
#define RDR2	(*(volatile unsigned char *)0xFFFFA5)
#define SCMR2	(*(volatile unsigned char *)0xFFFFA6)
#define DADRBH	(*(volatile unsigned char *)0xFFFFA6)
#define DACNTH	(*(volatile unsigned char *)0xFFFFA6)
#define DADRBL	(*(volatile unsigned char *)0xFFFFA7)
#define DACNTL	(*(volatile unsigned char *)0xFFFFA7)
#define TCSR0	(*(volatile unsigned char *)0xFFFFA8)
#define TCNT0_W	(*(volatile unsigned char *)0xFFFFA8)
#define TCNT0_R	(*(volatile unsigned char *)0xFFFFA9)
#define P1PCR	(*(volatile unsigned char *)0xFFFFAC)
#define P2PCR	(*(volatile unsigned char *)0xFFFFAD)
#define P3PCR	(*(volatile unsigned char *)0xFFFFAE)
#define P1DDR	(*(volatile unsigned char *)0xFFFFB0)
#define P2DDR	(*(volatile unsigned char *)0xFFFFB1)
#define P1DR	(*(volatile unsigned char *)0xFFFFB2)
#define P2DR	(*(volatile unsigned char *)0xFFFFB3)
#define P3DDR	(*(volatile unsigned char *)0xFFFFB4)
#define P4DDR	(*(volatile unsigned char *)0xFFFFB5)
#define P3DR	(*(volatile unsigned char *)0xFFFFB6)
#define P4DR	(*(volatile unsigned char *)0xFFFFB7)
#define P5DDR	(*(volatile unsigned char *)0xFFFFB8)
#define P6DDR	(*(volatile unsigned char *)0xFFFFB9)
#define P5DR	(*(volatile unsigned char *)0xFFFFBA)
#define P6DR	(*(volatile unsigned char *)0xFFFFBB)
#define P8DDR	(*(volatile unsigned char *)0xFFFFBD)
#define P7PIN	(*(volatile unsigned char *)0xFFFFBE)
#define P8DR	(*(volatile unsigned char *)0xFFFFBF)
#define P9DDR	(*(volatile unsigned char *)0xFFFFC0)
#define P9DR	(*(volatile unsigned char *)0xFFFFC1)
#define IER		(*(volatile unsigned char *)0xFFFFC2)
#define STCR	(*(volatile unsigned char *)0xFFFFC3)
#define SYSCR	(*(volatile unsigned char *)0xFFFFC4)
#define MDCR	(*(volatile unsigned char *)0xFFFFC5)
#define BCR		(*(volatile unsigned char *)0xFFFFC6)
#define WSCR	(*(volatile unsigned char *)0xFFFFC7)
#define TCR0	(*(volatile unsigned char *)0xFFFFC8)
#define TCR1	(*(volatile unsigned char *)0xFFFFC9)
#define TCSR0_	(*(volatile unsigned char *)0xFFFFCA)
#define TCSR1_	(*(volatile unsigned char *)0xFFFFCB)
#define TCORA0	(*(volatile unsigned char *)0xFFFFCC)
#define TCORA1	(*(volatile unsigned char *)0xFFFFCD)
#define TCORB0	(*(volatile unsigned char *)0xFFFFCE)
#define TCORB1	(*(volatile unsigned char *)0xFFFFCF)
#define TCNT0	(*(volatile unsigned char *)0xFFFFD0)
#define TCNT1	(*(volatile unsigned char *)0xFFFFD1)
#define PWOERB	(*(volatile unsigned char *)0xFFFFD2)
#define PWOERA	(*(volatile unsigned char *)0xFFFFD3)
#define PWDPRB	(*(volatile unsigned char *)0xFFFFD4)
#define PWDPRA	(*(volatile unsigned char *)0xFFFFD5)
#define PWSL	(*(volatile unsigned char *)0xFFFFD6)
#define PWDR	(*(volatile unsigned char *)0xFFFFD7)
#define SMR0	(*(volatile unsigned char *)0xFFFFD8)
#define ICCR0	(*(volatile unsigned char *)0xFFFFD8)
#define BRR0	(*(volatile unsigned char *)0xFFFFD9)
#define ICSR0	(*(volatile unsigned char *)0xFFFFD9)
#define SCR0	(*(volatile unsigned char *)0xFFFFDA)
#define TDR0	(*(volatile unsigned char *)0xFFFFDB)
#define SSR0	(*(volatile unsigned char *)0xFFFFDC)
#define RDR0	(*(volatile unsigned char *)0xFFFFDD)
#define SCMR0	(*(volatile unsigned char *)0xFFFFDE)
#define ICDR0	(*(volatile unsigned char *)0xFFFFDE)
#define SARX0	(*(volatile unsigned char *)0xFFFFDE)
#define ICMR0	(*(volatile unsigned char *)0xFFFFDF)
#define SAR0	(*(volatile unsigned char *)0xFFFFDF)
#define ADDRAH	(*(volatile unsigned char *)0xFFFFE0)
#define ADDRAL	(*(volatile unsigned char *)0xFFFFE1)
#define ADDRBH	(*(volatile unsigned char *)0xFFFFE2)
#define ADDRBL	(*(volatile unsigned char *)0xFFFFE3)
#define ADDRCH	(*(volatile unsigned char *)0xFFFFE4)
#define ADDRCL	(*(volatile unsigned char *)0xFFFFE5)
#define ADDRDH	(*(volatile unsigned char *)0xFFFFE6)
#define ADDRDL	(*(volatile unsigned char *)0xFFFFE7)
#define ADCSR	(*(volatile unsigned char *)0xFFFFE8)
#define ADCR	(*(volatile unsigned char *)0xFFFFE9)
#define TCSR1	(*(volatile unsigned char *)0xFFFFEA)
#define TCNT1_W	(*(volatile unsigned char *)0xFFFFEA)
#define TCNT1_R	(*(volatile unsigned char *)0xFFFFEB)
#define HICR	(*(volatile unsigned char *)0xFFFFF0)
#define TCRX	(*(volatile unsigned char *)0xFFFFF0)
#define TCRY	(*(volatile unsigned char *)0xFFFFF0)
#define KMIMR	(*(volatile unsigned char *)0xFFFFF1)
#define TCSRX	(*(volatile unsigned char *)0xFFFFF1)
#define TCSRY	(*(volatile unsigned char *)0xFFFFF1)
#define KMPCR	(*(volatile unsigned char *)0xFFFFF2)
#define TICRR	(*(volatile unsigned char *)0xFFFFF2)
#define TCORAY	(*(volatile unsigned char *)0xFFFFF2)
#define TICRF	(*(volatile unsigned char *)0xFFFFF3)
#define TCORBY	(*(volatile unsigned char *)0xFFFFF3)
#define IDR1	(*(volatile unsigned char *)0xFFFFF4)
#define TCNTX	(*(volatile unsigned char *)0xFFFFF4)
#define TCNTY	(*(volatile unsigned char *)0xFFFFF4)
#define ODR1	(*(volatile unsigned char *)0xFFFFF5)
#define TCORC	(*(volatile unsigned char *)0xFFFFF5)
#define TISR	(*(volatile unsigned char *)0xFFFFF5)
#define STR1	(*(volatile unsigned char *)0xFFFFF6)
#define TCORAX	(*(volatile unsigned char *)0xFFFFF6)
#define TCORBX	(*(volatile unsigned char *)0xFFFFF7)
#define DADR0	(*(volatile unsigned char *)0xFFFFF8)
#define DADR1	(*(volatile unsigned char *)0xFFFFF9)
#define DACR	(*(volatile unsigned char *)0xFFFFFA)
#define IDR2	(*(volatile unsigned char *)0xFFFFFC)
#define TCONRI	(*(volatile unsigned char *)0xFFFFFC)
#define ODR2	(*(volatile unsigned char *)0xFFFFFD)
#define TCONRO	(*(volatile unsigned char *)0xFFFFFD)
#define STR2	(*(volatile unsigned char *)0xFFFFFE)
#define TCONRS	(*(volatile unsigned char *)0xFFFFFE)
#define SEDGR	(*(volatile unsigned char *)0xFFFFFF)

// ===============================================================================================
//    }N
// ===============================================================================================

#define DisableINT		asm("orc.b #0xc0,ccr");
#define EnableINT		asm("andc.b #0x3f,ccr");
